<script lang="ts">
    import { createEventDispatcher, onDestroy } from 'svelte'
    import type Map from '$lib/map/Map'

    export let map: Map

    const dispatch = createEventDispatcher()

    const build = (stage: HTMLElement) => {
        map.setStage(stage).build()
        map.getDistrict().grid.subscribe(() => {
            map.draw()
        })
    }

    const resize = () => {
        map.resize().draw()
    }

    const mapHover = (event: MouseEvent) => {
        map.hover(event)
    }

    const mapClick = () => {
        map.select()
        dispatch('selectField', map.selected)
    }

    onDestroy(() => {
        map.destroy()
    })
</script>

<svelte:window on:resize={resize} />

<div id="stage" use:build>
    <canvas id="layer__background" />
    <canvas id="layer__map" />
    <canvas id="layer__interaction" />
    <!-- /!\ Events must be catched on the last layer -->
    <canvas id="layer__hover" on:mousemove={mapHover} on:click={mapClick} />
</div>

<style lang="postcss">
    #stage {
        @apply relative w-full h-full;

        :global(canvas) {
            @apply absolute bg-transparent;
        }
    }
</style>
